From a841b99abe41b5fb3008bb6b886a44e350681111 Mon Sep 17 00:00:00 2001
From: Kalle Valo <kvalo@codeaurora.org>
Date: Sat, 11 Nov 2017 10:48:17 +0200
Subject: [PATCH 08/12] pwcli: stg: review: delete all patches if user rejects
 or aborts

Otherwise the patches are left to the pending branch and can cause problems as
the user won't necessarily realise that they are still there.

Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---

Copyright (c) 2017, The Linux Foundation.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 cmdtests/cmd-review-stg-multiple-abort.stdout |  5 -----
 pwcli                                         | 16 +++++++++++-----
 2 files changed, 11 insertions(+), 10 deletions(-)

diff --git a/cmdtests/cmd-review-stg-multiple-abort.stdout b/cmdtests/cmd-review-stg-multiple-abort.stdout
index 33ee88f7e615..c81fcb73f3f7 100644
--- a/cmdtests/cmd-review-stg-multiple-abort.stdout
+++ b/cmdtests/cmd-review-stg-multiple-abort.stdout
@@ -47,9 +47,4 @@ b
 Aborted.
 master@data > stg list
 stg list
-[ 0] foo-new-patch
-[ 1] foo-minor-change-with-cc
-[ 2] foo-another-minor-change-with-multiple-to
-[ 3] bar-blah-blah-blah-1
-[ 4] bar-blah-blah-blah-2
 master@data > quit
diff --git a/pwcli b/pwcli
index b391a1d3d2d0..339d835f5e02 100755
--- a/pwcli
+++ b/pwcli
@@ -1992,9 +1992,6 @@ class PWCLI():
                     self.output('%s' % e.log)
                     faillog += e.log
 
-                    for i in range(len(applied)):
-                        self.stg.rollback()
-
             # Skip
             elif answer == 's':
                 # do nothing, just continue to state handling
@@ -2031,11 +2028,20 @@ class PWCLI():
                 elif len(builder.stderrdata) > 0:
                     result = 'Build had WARNINGS!'
 
+            if self.pending_mode == 'stgit' and state != PATCH_STATE_UNDER_REVIEW:
+                # User rejected the patches (or aborted) for some
+                # reason, so remove the patches from the pending branch.
+                for i in range(len(applied)):
+                    self.stg.rollback()
+
             if state != PATCH_STATE_UNDER_REVIEW or not result:
-                # no problems with patches
+                # User accepted the patches and there were no problems
+                # with the build. So no need to ask confirmation from
+                # the user.
                 break
 
-            # patches had problems and user chose to UNDER_REVIEW them
+            # patches had build problems and user still chose
+            # UNDER_REVIEW state for them
             self.output(result)
 
             answer = self.input(
-- 
2.7.4

